﻿using System.Windows;
using System.Windows.Controls;
using Infragistics.SampleGrid.Sources;
using System.Collections.ObjectModel;
using System;
using System.Linq;
using System.Collections.Generic;
using Infragistics.Controls.Grids;
using System.Threading;
using System.IO;
using Infragistics.Documents.Excel;

namespace Infragistics.SampleGrid
{
    public partial class MainPage : UserControl
    {
        #region DataSource

        private ObservableTestDataSource _dataSource;
        public ObservableTestDataSource DataSource
        {
            get { return this._dataSource; }
            private set { this._dataSource = value; }
        }

        #endregion // DataSource

        TestDataSourceTwo dataSource;
        public List<int> ComboColumnItemsSource { get; set; }


        public MainPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            dataSource = new TestDataSourceTwo();
            dataSource.Completed += dataSource_Completed;
            dataSource.LoadData();
        }

        void dataSource_Completed(object sender, EventArgs e)
        {
            MyHerarchicalGrid.ItemsSource = dataSource;
        }

        private void ExportBtn_Click(object sender, RoutedEventArgs e)
        {
            Workbook workbook1 = new Workbook();
            Worksheet worksheet1 = workbook1.Worksheets.Add("Sample Worksheet1");

            WorksheetRow worksheetRow;
            Column gridColumn;
            WorksheetCell worksheetCell;

            foreach (Row gridRow in this.MyHerarchicalGrid.Rows)
            {
                worksheetRow = worksheet1.Rows[gridRow.Index + 1];

                for (int columnIndex = 0; columnIndex < this.MyHerarchicalGrid.Columns.Count; columnIndex++)
                {
                    worksheetRow.Cells[columnIndex].Value = gridRow.Cells[columnIndex].Value;

                    if (gridRow.Index == 0)
                    {
                        worksheetCell = worksheet1.Rows[0].Cells[columnIndex];

                        gridColumn = this.MyHerarchicalGrid.Columns[columnIndex] as Column;

                        worksheetCell.Value = gridColumn.Key;
                    }
                }
            }

            SaveFileDialog savefileDialog = new SaveFileDialog { Filter = "Excel files|*.xls", DefaultExt = "xls" };

            if (savefileDialog.ShowDialog() == true)
            {
                Stream stream = savefileDialog.OpenFile();
                workbook1.Save(stream);
                stream.Close();
            }

        }
    }
}
