﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Media.Imaging;

namespace Infragistics.SampleGrid.Sources
{
    #region Models

    #region DeepBook3

    public partial class DeepBook3 : INotifyPropertyChanged
    {
        private string AuthorField;
        private bool FamousAuthorField;
        private ObservableCollection<InternetChapter> IChaptersField;
        private Uri InternetAddresField;
        private bool ReadOnlyFAField = true;
        private string TitleField;

        public string Author
        {
            get
            {
                return this.AuthorField;
            }

            set
            {
                if ((object.ReferenceEquals(this.AuthorField, value) != true))
                {
                    this.AuthorField = value;
                    this.RaisePropertyChanged("Author");
                }
            }
        }

        public bool FamousAuthor
        {
            get
            {
                return this.FamousAuthorField;
            }

            set
            {
                if ((this.FamousAuthorField.Equals(value) != true))
                {
                    this.FamousAuthorField = value;
                    this.RaisePropertyChanged("FamousAuthor");
                }
            }
        }

        public ObservableCollection<InternetChapter> IChapters
        {
            get
            {
                return this.IChaptersField;
            }

            set
            {
                if ((object.ReferenceEquals(this.IChaptersField, value) != true))
                {
                    this.IChaptersField = value;
                    this.RaisePropertyChanged("IChapters");
                }
            }
        }

        public Uri InternetAddres
        {
            get
            {
                return this.InternetAddresField;
            }

            set
            {
                if ((object.ReferenceEquals(this.InternetAddresField, value) != true))
                {
                    this.InternetAddresField = value;
                    this.RaisePropertyChanged("InternetAddres");
                }
            }
        }

        public bool ReadOnlyFA
        {
            get
            {
                return this.ReadOnlyFAField;
            }

            set
            {
                if ((this.ReadOnlyFAField.Equals(value) != true))
                {
                    this.ReadOnlyFAField = value;
                    this.RaisePropertyChanged("ReadOnlyFA");
                }
            }
        }

        public string Title
        {
            get
            {
                return this.TitleField;
            }

            set
            {
                if ((object.ReferenceEquals(this.TitleField, value) != true))
                {
                    this.TitleField = value;
                    this.RaisePropertyChanged("Title");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // DeepBook3

    #region InternetChapter

    public partial class InternetChapter : INotifyPropertyChanged
    {
        private bool GoodField;
        private Uri InternetTitleField;
        private bool ReadOnlyGoodField = true;

        public bool Good
        {
            get
            {
                return this.GoodField;
            }

            set
            {
                if ((this.GoodField.Equals(value) != true))
                {
                    this.GoodField = value;
                    this.RaisePropertyChanged("Good");
                }
            }
        }

        public Uri InternetTitle
        {
            get
            {
                return this.InternetTitleField;
            }

            set
            {
                if ((object.ReferenceEquals(this.InternetTitleField, value) != true))
                {
                    this.InternetTitleField = value;
                    this.RaisePropertyChanged("InternetTitle");
                }
            }
        }

        public bool ReadOnlyGood
        {
            get
            {
                return this.ReadOnlyGoodField;
            }

            set
            {
                if ((this.ReadOnlyGoodField.Equals(value) != true))
                {
                    this.ReadOnlyGoodField = value;
                    this.RaisePropertyChanged("ReadOnlyGood");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // InternetChapter

    #region Category

    public partial class Category : INotifyPropertyChanged
    {
        private int CategoryIDField;
        private string CategoryNameField;
        private string DescriptionField;
        private Binary PictureField;
        private bool ActiveField;
        private DateTime ActivationDateField;
        private string HomePageField;
        private ObservableCollection<Product> ProductsField;

        public int CategoryID
        {
            get
            {
                return this.CategoryIDField;
            }

            set
            {
                if ((this.CategoryIDField.Equals(value) != true))
                {
                    this.CategoryIDField = value;
                    this.RaisePropertyChanged("CategoryID");
                }
            }
        }

        public string CategoryName
        {
            get
            {
                return this.CategoryNameField;
            }

            set
            {
                if ((object.ReferenceEquals(this.CategoryNameField, value) != true))
                {
                    this.CategoryNameField = value;
                    this.RaisePropertyChanged("CategoryName");
                }
            }
        }

        public string Description
        {
            get
            {
                return this.DescriptionField;
            }

            set
            {
                if ((object.ReferenceEquals(this.DescriptionField, value) != true))
                {
                    this.DescriptionField = value;
                    this.RaisePropertyChanged("Description");
                }
            }
        }

        public Binary Picture
        {
            get
            {
                return this.PictureField;
            }

            set
            {
                if ((object.ReferenceEquals(this.PictureField, value) != true))
                {
                    this.PictureField = value;
                    this.RaisePropertyChanged("Picture");
                }
            }
        }

        public bool Active
        {
            get
            {
                return this.ActiveField;
            }

            set
            {
                if ((this.ActiveField.Equals(value) != true))
                {
                    this.ActiveField = value;
                    this.RaisePropertyChanged("Active");
                }
            }
        }

        public DateTime ActivationDate
        {
            get
            {
                return this.ActivationDateField;
            }

            set
            {
                if ((this.ActivationDateField.Equals(value) != true))
                {
                    this.ActivationDateField = value;
                    this.RaisePropertyChanged("ActivationDate");
                }
            }
        }

        public string HomePage
        {
            get
            {
                return this.HomePageField;
            }

            set
            {
                if ((object.ReferenceEquals(this.HomePageField, value) != true))
                {
                    this.HomePageField = value;
                    this.RaisePropertyChanged("HomePage");
                }
            }
        }

        public ObservableCollection<Product> Products
        {
            get
            {
                return this.ProductsField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ProductsField, value) != true))
                {
                    this.ProductsField = value;
                    this.RaisePropertyChanged("Products");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // Category

    #region Product

    public partial class Product : INotifyPropertyChanged
    {
        private int ProductIDField;
        private string ProductNameField;
        private Nullable<int> SupplierIDField;
        private Nullable<int> CategoryIDField;
        private string QuantityPerUnitField;
        private Nullable<decimal> UnitPriceField;
        private Nullable<short> UnitsInStockField;
        private Nullable<short> UnitsOnOrderField;
        private Nullable<short> ReorderLevelField;
        private bool DiscontinuedField;
        private DateTime DiscontinuityDateField;
        private string HomePageField;

        public int ProductID
        {
            get
            {
                return this.ProductIDField;
            }

            set
            {
                if ((this.ProductIDField.Equals(value) != true))
                {
                    this.ProductIDField = value;
                    this.RaisePropertyChanged("ProductID");
                }
            }
        }

        public string ProductName
        {
            get
            {
                return this.ProductNameField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ProductNameField, value) != true))
                {
                    this.ProductNameField = value;
                    this.RaisePropertyChanged("ProductName");
                }
            }
        }

        public Nullable<int> SupplierID
        {
            get
            {
                return this.SupplierIDField;
            }

            set
            {
                if ((this.SupplierIDField.Equals(value) != true))
                {
                    this.SupplierIDField = value;
                    this.RaisePropertyChanged("SupplierID");
                }
            }
        }

        public Nullable<int> CategoryID
        {
            get
            {
                return this.CategoryIDField;
            }

            set
            {
                if ((this.CategoryIDField.Equals(value) != true))
                {
                    this.CategoryIDField = value;
                    this.RaisePropertyChanged("CategoryID");
                }
            }
        }

        public string QuantityPerUnit
        {
            get
            {
                return this.QuantityPerUnitField;
            }

            set
            {
                if ((object.ReferenceEquals(this.QuantityPerUnitField, value) != true))
                {
                    this.QuantityPerUnitField = value;
                    this.RaisePropertyChanged("QuantityPerUnit");
                }
            }
        }

        public Nullable<decimal> UnitPrice
        {
            get
            {
                return this.UnitPriceField;
            }

            set
            {
                if ((this.UnitPriceField.Equals(value) != true))
                {
                    this.UnitPriceField = value;
                    this.RaisePropertyChanged("UnitPrice");
                }
            }
        }

        public Nullable<short> UnitsInStock
        {
            get
            {
                return this.UnitsInStockField;
            }

            set
            {
                if ((this.UnitsInStockField.Equals(value) != true))
                {
                    this.UnitsInStockField = value;
                    this.RaisePropertyChanged("UnitsInStock");
                }
            }
        }

        public Nullable<short> UnitsOnOrder
        {
            get
            {
                return this.UnitsOnOrderField;
            }

            set
            {
                if ((this.UnitsOnOrderField.Equals(value) != true))
                {
                    this.UnitsOnOrderField = value;
                    this.RaisePropertyChanged("UnitsOnOrder");
                }
            }
        }

        public Nullable<short> ReorderLevel
        {
            get
            {
                return this.ReorderLevelField;
            }

            set
            {
                if ((this.ReorderLevelField.Equals(value) != true))
                {
                    this.ReorderLevelField = value;
                    this.RaisePropertyChanged("ReorderLevel");
                }
            }
        }

        public bool Discontinued
        {
            get
            {
                return this.DiscontinuedField;
            }

            set
            {
                if ((this.DiscontinuedField.Equals(value) != true))
                {
                    this.DiscontinuedField = value;
                    this.RaisePropertyChanged("Discontinued");
                }
            }
        }

        public DateTime DiscontinuityDate
        {
            get
            {
                return this.DiscontinuityDateField;
            }

            set
            {
                if ((this.DiscontinuityDateField.Equals(value) != true))
                {
                    this.DiscontinuityDateField = value;
                    this.RaisePropertyChanged("DiscontinuityDate");
                }
            }
        }

        public string HomePage
        {
            get
            {
                return this.HomePageField;
            }

            set
            {
                if ((object.ReferenceEquals(this.HomePageField, value) != true))
                {
                    this.HomePageField = value;
                    this.RaisePropertyChanged("HomePage");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // Product

    #region Binary

    public class Binary : INotifyPropertyChanged
    {
        private byte[] BytesField;

        public byte[] Bytes
        {
            get
            {
                return this.BytesField;
            }

            set
            {
                if ((object.ReferenceEquals(this.BytesField, value) != true))
                {
                    this.BytesField = value;
                    this.RaisePropertyChanged("Bytes");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // Binary

    #region Book

    public partial class Book : INotifyPropertyChanged
    {
        private string AuthorField;
        private ObservableCollection<Chapter> ChaptersField;
        private string ISBNField;
        private string TitleField;

        public string Author
        {
            get
            {
                return this.AuthorField;
            }

            set
            {
                if ((object.ReferenceEquals(this.AuthorField, value) != true))
                {
                    this.AuthorField = value;
                    this.RaisePropertyChanged("Author");
                }
            }
        }

        public ObservableCollection<Chapter> Chapters
        {
            get
            {
                return this.ChaptersField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ChaptersField, value) != true))
                {
                    this.ChaptersField = value;
                    this.RaisePropertyChanged("Chapters");
                }
            }
        }

        public string ISBN
        {
            get
            {
                return this.ISBNField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ISBNField, value) != true))
                {
                    this.ISBNField = value;
                    this.RaisePropertyChanged("ISBN");
                }
            }
        }

        public string Title
        {
            get
            {
                return this.TitleField;
            }

            set
            {
                if ((object.ReferenceEquals(this.TitleField, value) != true))
                {
                    this.TitleField = value;
                    this.RaisePropertyChanged("Title");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // Book

    #region Chapter

    public partial class Chapter : INotifyPropertyChanged
    {

        private string TitleField;

        public string Title
        {
            get
            {
                return this.TitleField;
            }

            set
            {
                if ((object.ReferenceEquals(this.TitleField, value) != true))
                {
                    this.TitleField = value;
                    this.RaisePropertyChanged("Title");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // Chapter

    #region Person

    public partial class Person : INotifyPropertyChanged
    {
        private string FirstNameField;
        private string LastNameField;

        public string FirstName
        {
            get
            {
                return this.FirstNameField;
            }

            set
            {
                if ((object.ReferenceEquals(this.FirstNameField, value) != true))
                {
                    this.FirstNameField = value;
                    this.RaisePropertyChanged("FirstName");
                }
            }
        }

        public string LastName
        {
            get
            {
                return this.LastNameField;
            }

            set
            {
                if ((object.ReferenceEquals(this.LastNameField, value) != true))
                {
                    this.LastNameField = value;
                    this.RaisePropertyChanged("LastName");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // Person

    #region BigBook

    public partial class BigBook : INotifyPropertyChanged
    {
        private string AuthorField;
        private ObservableCollection<Chapter> ChaptersField;
        private ObservableCollection<Chapter> ExpandChaptersField;
        private string ISBNField;
        private string InternetAddresField;
        private string TitleField;

        public string Author
        {
            get
            {
                return this.AuthorField;
            }

            set
            {
                if ((object.ReferenceEquals(this.AuthorField, value) != true))
                {
                    this.AuthorField = value;
                    this.RaisePropertyChanged("Author");
                }
            }
        }

        public ObservableCollection<Chapter> Chapters
        {
            get
            {
                return this.ChaptersField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ChaptersField, value) != true))
                {
                    this.ChaptersField = value;
                    this.RaisePropertyChanged("Chapters");
                }
            }
        }

        public ObservableCollection<Chapter> ExpandChapters
        {
            get
            {
                return this.ExpandChaptersField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ExpandChaptersField, value) != true))
                {
                    this.ExpandChaptersField = value;
                    this.RaisePropertyChanged("ExpandChapters");
                }
            }
        }

        public string ISBN
        {
            get
            {
                return this.ISBNField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ISBNField, value) != true))
                {
                    this.ISBNField = value;
                    this.RaisePropertyChanged("ISBN");
                }
            }
        }

        public string InternetAddres
        {
            get
            {
                return this.InternetAddresField;
            }

            set
            {
                if ((object.ReferenceEquals(this.InternetAddresField, value) != true))
                {
                    this.InternetAddresField = value;
                    this.RaisePropertyChanged("InternetAddres");
                }
            }
        }

        public string Title
        {
            get
            {
                return this.TitleField;
            }

            set
            {
                if ((object.ReferenceEquals(this.TitleField, value) != true))
                {
                    this.TitleField = value;
                    this.RaisePropertyChanged("Title");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // BigBook

    #region DeepBook

    public partial class DeepBook : INotifyPropertyChanged
    {
        private string AuthorField;
        private ObservableCollection<Chapter> ChaptersField;
        private ObservableCollection<ObservableCollection<Chapter>> ExpandChaptersField;
        private string ISBNField;
        private string InternetAddresField;
        private string TitleField;

        public string Author
        {
            get
            {
                return this.AuthorField;
            }

            set
            {
                if ((object.ReferenceEquals(this.AuthorField, value) != true))
                {
                    this.AuthorField = value;
                    this.RaisePropertyChanged("Author");
                }
            }
        }

        public ObservableCollection<Chapter> Chapters
        {
            get
            {
                return this.ChaptersField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ChaptersField, value) != true))
                {
                    this.ChaptersField = value;
                    this.RaisePropertyChanged("Chapters");
                }
            }
        }


        public ObservableCollection<ObservableCollection<Chapter>> ExpandChapters
        {
            get
            {
                return this.ExpandChaptersField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ExpandChaptersField, value) != true))
                {
                    this.ExpandChaptersField = value;
                    this.RaisePropertyChanged("ExpandChapters");
                }
            }
        }


        public string ISBN
        {
            get
            {
                return this.ISBNField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ISBNField, value) != true))
                {
                    this.ISBNField = value;
                    this.RaisePropertyChanged("ISBN");
                }
            }
        }


        public string InternetAddres
        {
            get
            {
                return this.InternetAddresField;
            }

            set
            {
                if ((object.ReferenceEquals(this.InternetAddresField, value) != true))
                {
                    this.InternetAddresField = value;
                    this.RaisePropertyChanged("InternetAddres");
                }
            }
        }


        public string Title
        {
            get
            {
                return this.TitleField;
            }

            set
            {
                if ((object.ReferenceEquals(this.TitleField, value) != true))
                {
                    this.TitleField = value;
                    this.RaisePropertyChanged("Title");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // DeepBook

    #region DeepBook2

    public partial class DeepBook2 : INotifyPropertyChanged
    {
        private string AuthorField;
        private ObservableCollection<Book> ChaptersField;
        private ObservableCollection<Chapter> ExpandChaptersField;
        private bool FamousAuthorField;
        private string ISBNField;
        private Uri InternetAddresField;
        private string TitleField;

        public string Author
        {
            get
            {
                return this.AuthorField;
            }

            set
            {
                if ((object.ReferenceEquals(this.AuthorField, value) != true))
                {
                    this.AuthorField = value;
                    this.RaisePropertyChanged("Author");
                }
            }
        }

        public ObservableCollection<Book> Chapters
        {
            get
            {
                return this.ChaptersField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ChaptersField, value) != true))
                {
                    this.ChaptersField = value;
                    this.RaisePropertyChanged("Chapters");
                }
            }
        }

        public ObservableCollection<Chapter> ExpandChapters
        {
            get
            {
                return this.ExpandChaptersField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ExpandChaptersField, value) != true))
                {
                    this.ExpandChaptersField = value;
                    this.RaisePropertyChanged("ExpandChapters");
                }
            }
        }

        public bool FamousAuthor
        {
            get
            {
                return this.FamousAuthorField;
            }

            set
            {
                if ((this.FamousAuthorField.Equals(value) != true))
                {
                    this.FamousAuthorField = value;
                    this.RaisePropertyChanged("FamousAuthor");
                }
            }
        }

        public string ISBN
        {
            get
            {
                return this.ISBNField;
            }

            set
            {
                if ((object.ReferenceEquals(this.ISBNField, value) != true))
                {
                    this.ISBNField = value;
                    this.RaisePropertyChanged("ISBN");
                }
            }
        }

        public Uri InternetAddres
        {
            get
            {
                return this.InternetAddresField;
            }

            set
            {
                if ((object.ReferenceEquals(this.InternetAddresField, value) != true))
                {
                    this.InternetAddresField = value;
                    this.RaisePropertyChanged("InternetAddres");
                }
            }
        }

        public string Title
        {
            get
            {
                return this.TitleField;
            }

            set
            {
                if ((object.ReferenceEquals(this.TitleField, value) != true))
                {
                    this.TitleField = value;
                    this.RaisePropertyChanged("Title");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // DeepBook2

    #region BookStore

    public partial class BookStore : INotifyPropertyChanged
    {
        private string StoreNameField;
        private string LocationField;
        private ObservableCollection<Book> BooksField;
        private ObservableCollection<Magazine> MagazinesField;

        public string StoreName
        {
            get
            {
                return this.StoreNameField;
            }
            set
            {
                if ((object.ReferenceEquals(this.StoreNameField, value) != true))
                {
                    this.StoreNameField = value;
                    this.RaisePropertyChanged("StoreName");
                }
            }
        }
        public string Location
        {
            get
            {
                return this.LocationField;
            }
            set
            {
                if ((object.ReferenceEquals(this.LocationField, value) != true))
                {
                    this.LocationField = value;
                    this.RaisePropertyChanged("Location");
                }
            }
        }
        public ObservableCollection<Book> Books
        {
            get
            {
                return this.BooksField;
            }
            set
            {
                if ((object.ReferenceEquals(this.BooksField, value) != true))
                {
                    this.BooksField = value;
                    this.RaisePropertyChanged("Books");
                }
            }
        }
        public ObservableCollection<Magazine> Magazines
        {
            get
            {
                return this.MagazinesField;
            }
            set
            {
                if ((object.ReferenceEquals(this.MagazinesField, value) != true))
                {
                    this.MagazinesField = value;
                    this.RaisePropertyChanged("Magazines");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // BookStore

    #region Magazine

    public partial class Magazine : INotifyPropertyChanged
    {
        private string AuthorField;
        private string MagazineTitleField;
        private ObservableCollection<Edition> EditionsField;

        public string Author
        {
            get
            {
                return this.AuthorField;
            }
            set
            {
                if ((object.ReferenceEquals(this.AuthorField, value) != true))
                {
                    this.AuthorField = value;
                    this.RaisePropertyChanged("Author");
                }
            }
        }
        public string MagazineTitle
        {
            get
            {
                return this.MagazineTitleField;
            }
            set
            {
                if ((object.ReferenceEquals(this.MagazineTitleField, value) != true))
                {
                    this.MagazineTitleField = value;
                    this.RaisePropertyChanged("MagazineTitle");
                }
            }
        }
        public ObservableCollection<Edition> Editions
        {
            get
            {
                return this.EditionsField;
            }
            set
            {
                if ((object.ReferenceEquals(this.EditionsField, value) != true))
                {
                    this.EditionsField = value;
                    this.RaisePropertyChanged("Editions");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // Magazine

    #region MagazineExt

    public partial class MagazineExt : INotifyPropertyChanged
    {
        private string AuthorField;
        private string MagazineTitleField;
        private Uri InternetAddressField;
        private ObservableCollection<Edition> EditionsField;

        public string Author
        {
            get
            {
                return this.AuthorField;
            }
            set
            {
                if ((object.ReferenceEquals(this.AuthorField, value) != true))
                {
                    this.AuthorField = value;
                    this.RaisePropertyChanged("Author");
                }
            }
        }
        public string MagazineTitle
        {
            get
            {
                return this.MagazineTitleField;
            }
            set
            {
                if ((object.ReferenceEquals(this.MagazineTitleField, value) != true))
                {
                    this.MagazineTitleField = value;
                    this.RaisePropertyChanged("MagazineTitle");
                }
            }
        }
        public Uri InternetAddress
        {
            get
            {
                return this.InternetAddressField;
            }
            set
            {
                if ((object.ReferenceEquals(this.InternetAddressField, value) != true))
                {
                    this.InternetAddressField = value;
                    this.RaisePropertyChanged("InternetAddress");
                }
            }
        }
        public ObservableCollection<Edition> Editions
        {
            get
            {
                if (this.EditionsField == null)
                {
                    this.EditionsField = new ObservableCollection<Edition>();
                }

                return this.EditionsField;
            }
            set
            {
                if ((object.ReferenceEquals(this.EditionsField, value) != true))
                {
                    this.EditionsField = value;
                    this.RaisePropertyChanged("Editions");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // Magazine

    #region Edition

    public partial class Edition : INotifyPropertyChanged
    {
        private string EditionNameField;
        private double PriceField;
        private ObservableCollection<Rubric> RubricsField;

        public string EditionName
        {
            get
            {
                return this.EditionNameField;
            }
            set
            {
                if ((object.ReferenceEquals(this.EditionNameField, value) != true))
                {
                    this.EditionNameField = value;
                    this.RaisePropertyChanged("EditionName");
                }
            }
        }
        public double Price
        {
            get
            {
                return this.PriceField;
            }
            set
            {
                if ((object.ReferenceEquals(this.PriceField, value) != true))
                {
                    this.PriceField = value;
                    this.RaisePropertyChanged("Price");
                }
            }
        }
        public ObservableCollection<Rubric> Rubrics
        {
            get
            {
                return this.RubricsField;
            }
            set
            {
                if ((object.ReferenceEquals(this.RubricsField, value) != true))
                {
                    this.RubricsField = value;
                    this.RaisePropertyChanged("Rubrics");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // Edition

    #region Rubric

    public partial class Rubric : INotifyPropertyChanged
    {
        private string HeadingField;
        private int IndexField;
        private DateTime PublishDateField;

        public string Heading
        {
            get
            {
                return this.HeadingField;
            }
            set
            {
                if ((object.ReferenceEquals(this.HeadingField, value) != true))
                {
                    this.HeadingField = value;
                    this.RaisePropertyChanged("Heading");
                }
            }
        }
        public DateTime PublishDate
        {
            get
            {
                return this.PublishDateField;
            }
            set
            {
                if ((object.ReferenceEquals(this.PublishDateField, value) != true))
                {
                    this.PublishDateField = value;
                    this.RaisePropertyChanged("PublishDate");
                }
            }
        }
        public int Index
        {
            get
            {
                return this.IndexField;
            }
            set
            {
                if ((object.ReferenceEquals(this.IndexField, value) != true))
                {
                    this.IndexField = value;
                    this.RaisePropertyChanged("Index");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
    public partial class RubricExt : INotifyPropertyChanged
    {
        private string HeadingField;
        private int IndexField;
        private DateTime PublishDateField;
        private BitmapImage PictureField;

        public string Heading
        {
            get
            {
                return this.HeadingField;
            }
            set
            {
                if ((object.ReferenceEquals(this.HeadingField, value) != true))
                {
                    this.HeadingField = value;
                    this.RaisePropertyChanged("Heading");
                }
            }
        }
        public DateTime PublishDate
        {
            get
            {
                return this.PublishDateField;
            }
            set
            {
                if ((object.ReferenceEquals(this.PublishDateField, value) != true))
                {
                    this.PublishDateField = value;
                    this.RaisePropertyChanged("PublishDate");
                }
            }
        }
        public int Index
        {
            get
            {
                return this.IndexField;
            }
            set
            {
                if ((object.ReferenceEquals(this.IndexField, value) != true))
                {
                    this.IndexField = value;
                    this.RaisePropertyChanged("Index");
                }
            }
        }
        public BitmapImage Picture
        {
            get
            {
                return this.PictureField;
            }
            set
            {
                if ((object.ReferenceEquals(this.PictureField, value) != true))
                {
                    this.PictureField = value;
                    this.RaisePropertyChanged("Picture");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // Rubric

    #region BookCategory

    public partial class BookCategory : INotifyPropertyChanged
    {
        private string CategoryNameField;
        private ObservableCollection<Book> BooksField;

        public string CategoryName
        {
            get
            {
                return this.CategoryNameField;
            }
            set
            {
                if ((object.ReferenceEquals(this.CategoryNameField, value) != true))
                {
                    this.CategoryNameField = value;
                    this.RaisePropertyChanged("CategoryName");
                }
            }
        }
        public ObservableCollection<Book> Books
        {
            get
            {
                return this.BooksField;
            }
            set
            {
                if ((object.ReferenceEquals(this.BooksField, value) != true))
                {
                    this.BooksField = value;
                    this.RaisePropertyChanged("Books");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    #endregion // BookCategory

    #endregion // Models

    #region DataGenerators

    public class DataGenerator
    {
        #region GetPeople

        public static ObservableCollection<Person> GetPeople()
        {
            ObservableCollection<Person> ppl = new ObservableCollection<Person>();

            ppl.Add(new Person()
            {
                FirstName = "Tim",
                LastName = "Roger"
            });

            ppl.Add(new Person()
            {
                FirstName = "Bob",
                LastName = "Crunny"
            });

            ppl.Add(new Person()
            {
                FirstName = "Garry",
                LastName = "Rock"
            });


            return ppl;
        }

        #endregion // GetPeople

        #region EBooks

        public static ObservableCollection<Book> EBooks()
        {
            Book book1 = new Book();
            Book book2 = new Book();
            Book book3 = new Book();

            book1.Title = "Harry Potter and the Deathly Hallows";
            book1.Author = "J. K. Rowling";
            book1.ISBN = "0545010225";
            book1.Chapters = new ObservableCollection<Chapter> { 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "In memoriam" }, 
                new Chapter { Title = "The Dursleys departing" }, 
                new Chapter { Title = "The seven Potters" }, 
                new Chapter { Title = "Fallen warrior" }, 
                new Chapter { Title = "The ghoul in pajamas" }, 
                new Chapter { Title = "The will of Albus Dumbledore" }, 
                new Chapter { Title = "The wedding" }, 
                new Chapter { Title = "A place to hide" }, 
                new Chapter { Title = "Kreacher's tale" }, 
                new Chapter { Title = "The bribe" }, 
                new Chapter { Title = "Magic is might" }, 
                new Chapter { Title = "The Muggle-born Registration Commission" }, 
                new Chapter { Title = "The thief" }, 
                new Chapter { Title = "The goblin's revenge" }, 
                new Chapter { Title = "Godric's Hollow" }, 
                new Chapter { Title = "Bathilda's secret" }, 
                new Chapter { Title = "The life and lies of Albus Dumbledore" }, 
                new Chapter { Title = "The silver doe" }, 
                new Chapter { Title = "Xenophilius Lovegood" }, 
                new Chapter { Title = "The tale of the three brothers" }, 
                new Chapter { Title = "The Deathly Hallows" }, 
                new Chapter { Title = "Malfoy Manor" }, 
                new Chapter { Title = "The wandmaker" }, 
                new Chapter { Title = "Shell Cottage" }, 
                new Chapter { Title = "Gringotts" }, 
                new Chapter { Title = "The final hiding place" }, 
                new Chapter { Title = "The missing mirror" }, 
                new Chapter { Title = "The lost diadem" }, 
                new Chapter { Title = "The sacking of Severus Snape" }, 
                new Chapter { Title = "The Battle of Hogwarts" }, 
                new Chapter { Title = "The Elder Wand" }, 
                new Chapter { Title = "The prince's tale" }, 
                new Chapter { Title = "The forest again" }, 
                new Chapter { Title = "King's Cross" }, 
                new Chapter { Title = "The flaw in the plan" }
        };

            book2.Title = "Silverlight 2 Programmer's Reference";
            book2.Author = "J. Ambrose Little, Jason Beres, Grant Hinkson, Devin Rader, Joe Croney";
            book2.ISBN = "0470385405";

            book3.Title = "Silverlight 1.0";
            book3.Author = "Devin Rader, Jason Beres, J. Ambrose Little, Grant Hinkson";
            book3.ISBN = "0470228407";
            book3.Chapters = new ObservableCollection<Chapter>() {
                new Chapter { Title = "Introduction to Silverlight"},
                new Chapter { Title = "Building Silverlight Applications Using XAML"}, 
                new Chapter { Title = "Designing Silverlight Applications Using Expression Blend 2"}, 
                new Chapter { Title = "Coding Silverlight Applications with JavaScript and XAML"}, 
                new Chapter { Title = "Using Silverlight with ASP.NET"}, 
                new Chapter { Title = "Silverlight 1.1 and the CLR"},
                new Chapter { Title = "Video Player: Silverlight 1.0 Case Example"}
        };

            ObservableCollection<Book> books = new ObservableCollection<Book>() { book1, book2, book3 };
            return books;
        }
        public static ObservableCollection<Book> ELimitedBooks()
        {
            Book book1 = new Book();
            Book book2 = new Book();
            Book book3 = new Book();

            book1.Title = "Harry Potter and the Deathly Hallows";
            book1.Author = "J. K. Rowling";
            book1.ISBN = "0545010225";
            book1.Chapters = new ObservableCollection<Chapter> { 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "In memoriam" }, 
                new Chapter { Title = "The Dursleys departing" }, 
                new Chapter { Title = "The seven Potters" }, 
                new Chapter { Title = "Fallen warrior" }, 
        };

            book2.Title = "Silverlight 2 Programmer's Reference";
            book2.Author = "J. Ambrose Little, Jason Beres, Grant Hinkson, Devin Rader, Joe Croney";
            book2.ISBN = "0470385405";

            book3.Title = "Silverlight 1.0";
            book3.Author = "Devin Rader, Jason Beres, J. Ambrose Little, Grant Hinkson";
            book3.ISBN = "0470228407";
            book3.Chapters = new ObservableCollection<Chapter>() {
                new Chapter { Title = "Introduction to Silverlight"},
                new Chapter { Title = "Using Silverlight with ASP.NET"}, 
                new Chapter { Title = "Silverlight 1.1 and the CLR"},
                new Chapter { Title = "Video Player: Silverlight 1.0 Case Example"}
        };

            ObservableCollection<Book> books = new ObservableCollection<Book>() { book1, book2, book3 };
            return books;
        }

        #endregion // EBooks

        #region EBigBooks

        public static ObservableCollection<BigBook> EBigBooks()
        {
            BigBook book1 = new BigBook();
            BigBook book2 = new BigBook();
            BigBook book3 = new BigBook();

            book1.Title = "Harry Potter and the Deathly Hallows";
            book1.Author = "J. K. Rowling";
            book1.ISBN = "0545010225";
            book1.InternetAddres = "www.google.com";
            book1.Chapters = new ObservableCollection<Chapter> { 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "In memoriam" }, 
                new Chapter { Title = "The Dursleys departing" }, 
                new Chapter { Title = "The seven Potters" }, 
                new Chapter { Title = "Fallen warrior" }, 
                new Chapter { Title = "The ghoul in pajamas" }, 
                new Chapter { Title = "The will of Albus Dumbledore" }, 
                new Chapter { Title = "The wedding" }, 
                new Chapter { Title = "A place to hide" }, 
                new Chapter { Title = "Kreacher's tale" }, 
                new Chapter { Title = "The bribe" }, 
                new Chapter { Title = "Magic is might" }, 
                new Chapter { Title = "The Muggle-born Registration Commission" }, 
                new Chapter { Title = "The thief" }, 
                new Chapter { Title = "The goblin's revenge" }, 
                new Chapter { Title = "Godric's Hollow" }, 
                new Chapter { Title = "Bathilda's secret" }, 
                new Chapter { Title = "The life and lies of Albus Dumbledore" }, 
                new Chapter { Title = "The silver doe" }, 
                new Chapter { Title = "Xenophilius Lovegood" }, 
                new Chapter { Title = "The tale of the three brothers" }, 
                new Chapter { Title = "The Deathly Hallows" }, 
                new Chapter { Title = "Malfoy Manor" }, 
                new Chapter { Title = "The wandmaker" }, 
                new Chapter { Title = "Shell Cottage" }, 
                new Chapter { Title = "Gringotts" }, 
                new Chapter { Title = "The final hiding place" }, 
                new Chapter { Title = "The missing mirror" }, 
                new Chapter { Title = "The lost diadem" }, 
                new Chapter { Title = "The sacking of Severus Snape" }, 
                new Chapter { Title = "The Battle of Hogwarts" }, 
                new Chapter { Title = "The Elder Wand" }, 
                new Chapter { Title = "The prince's tale" }, 
                new Chapter { Title = "The forest again" }, 
                new Chapter { Title = "King's Cross" }, 
                new Chapter { Title = "The flaw in the plan" }
        };


            book1.ExpandChapters = new ObservableCollection<Chapter> { 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "In memoriam" }, 
                new Chapter { Title = "The Dursleys departing" }, 
                new Chapter { Title = "The seven Potters" }, 
                new Chapter { Title = "Fallen warrior" }, 
                new Chapter { Title = "The ghoul in pajamas" }, 
                new Chapter { Title = "The will of Albus Dumbledore" }, 
                new Chapter { Title = "The wedding" }, 
                new Chapter { Title = "A place to hide" }, 
                new Chapter { Title = "Kreacher's tale" }, 
                new Chapter { Title = "The bribe" }, 
                new Chapter { Title = "Magic is might" }, 
                new Chapter { Title = "The Muggle-born Registration Commission" }, 
                new Chapter { Title = "The thief" }, 
                new Chapter { Title = "The goblin's revenge" }, 
                new Chapter { Title = "Godric's Hollow" }, 
                new Chapter { Title = "Bathilda's secret" }, 
                new Chapter { Title = "The life and lies of Albus Dumbledore" }, 
                new Chapter { Title = "The silver doe" }, 
                new Chapter { Title = "Xenophilius Lovegood" }, 
                new Chapter { Title = "The tale of the three brothers" }, 
                new Chapter { Title = "The Deathly Hallows" }, 
                new Chapter { Title = "Malfoy Manor" }, 
                new Chapter { Title = "The wandmaker" }, 
                new Chapter { Title = "Shell Cottage" }, 
                new Chapter { Title = "Gringotts" }, 
                new Chapter { Title = "The final hiding place" }, 
                new Chapter { Title = "The missing mirror" }, 
                new Chapter { Title = "The lost diadem" }, 
                new Chapter { Title = "The sacking of Severus Snape" }, 
                new Chapter { Title = "The Battle of Hogwarts" }, 
                new Chapter { Title = "The Elder Wand" }, 
                new Chapter { Title = "The prince's tale" }, 
                new Chapter { Title = "The forest again" }, 
                new Chapter { Title = "King's Cross" }, 
                new Chapter { Title = "The flaw in the plan" },
                new Chapter { Title = "The forest again" }, 
                new Chapter { Title = "King's Cross" }, 
                new Chapter { Title = "The flaw in the plan" }
        };

            book2.Title = "Silverlight 2 Programmer's Reference";
            book2.Author = "J. Ambrose Little, Jason Beres, Grant Hinkson, Devin Rader, Joe Croney";
            book2.ISBN = "0470385405";
            book2.InternetAddres = "www.google.com";

            book3.Title = "Silverlight 1.0";
            book3.Author = "Devin Rader, Jason Beres, J. Ambrose Little, Grant Hinkson";
            book3.ISBN = "0470228407";
            book3.InternetAddres = "www.google.com";
            book3.Chapters = new ObservableCollection<Chapter>() {
                new Chapter { Title = "Introduction to Silverlight"},
                new Chapter { Title = "Building Silverlight Applications Using XAML"}, 
                new Chapter { Title = "Designing Silverlight Applications Using Expression Blend 2"}, 
                new Chapter { Title = "Coding Silverlight Applications with JavaScript and XAML"}, 
                new Chapter { Title = "Using Silverlight with ASP.NET"}, 
                new Chapter { Title = "Silverlight 1.1 and the CLR"},
                new Chapter { Title = "Video Player: Silverlight 1.0 Case Example"}
        };
            book3.ExpandChapters = new ObservableCollection<Chapter>() {
                new Chapter { Title = "Introduction to Silverlight"},
                new Chapter { Title = "Building Silverlight Applications Using XAML"}, 
                new Chapter { Title = "Designing Silverlight Applications Using Expression Blend 2"}, 
                new Chapter { Title = "Coding Silverlight Applications with JavaScript and XAML"}, 
                new Chapter { Title = "Using Silverlight with ASP.NET"}, 
                new Chapter { Title = "Silverlight 1.1 and the CLR"},
                new Chapter { Title = "Video Player: Silverlight 1.0 Case Example"}
        };

            ObservableCollection<BigBook> bigBooks = new ObservableCollection<BigBook>() { book1, book2, book3 };
            return bigBooks;
        }

        #endregion // EBigBooks

        #region EDeepBooks

        public static ObservableCollection<DeepBook> EDeepBooks()
        {
            DeepBook book1 = new DeepBook();
            DeepBook book2 = new DeepBook();
            DeepBook book3 = new DeepBook();

            book1.Title = "Harry Potter and the Deathly Hallows";
            book1.Author = "J. K. Rowling";
            book1.ISBN = "0545010225";
            book1.InternetAddres = "www.google.com";
            #region Chapters
            book1.Chapters = new ObservableCollection<Chapter> { 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "In memoriam" }, 
                new Chapter { Title = "The Dursleys departing" }, 
                new Chapter { Title = "The seven Potters" }, 
                new Chapter { Title = "Fallen warrior" }, 
                new Chapter { Title = "The ghoul in pajamas" }, 
                new Chapter { Title = "The will of Albus Dumbledore" }, 
                new Chapter { Title = "The wedding" }, 
                new Chapter { Title = "A place to hide" }, 
                new Chapter { Title = "Kreacher's tale" }, 
                new Chapter { Title = "The bribe" }, 
                new Chapter { Title = "Magic is might" }, 
                new Chapter { Title = "The Muggle-born Registration Commission" }, 
                new Chapter { Title = "The thief" }, 
                new Chapter { Title = "The goblin's revenge" }, 
                new Chapter { Title = "Godric's Hollow" }, 
                new Chapter { Title = "Bathilda's secret" }, 
                new Chapter { Title = "The life and lies of Albus Dumbledore" }, 
                new Chapter { Title = "The silver doe" }, 
                new Chapter { Title = "Xenophilius Lovegood" }, 
                new Chapter { Title = "The tale of the three brothers" }, 
                new Chapter { Title = "The Deathly Hallows" }, 
                new Chapter { Title = "Malfoy Manor" }, 
                new Chapter { Title = "The wandmaker" }, 
                new Chapter { Title = "Shell Cottage" }, 
                new Chapter { Title = "Gringotts" }, 
                new Chapter { Title = "The final hiding place" }, 
                new Chapter { Title = "The missing mirror" }, 
                new Chapter { Title = "The lost diadem" }, 
                new Chapter { Title = "The sacking of Severus Snape" }, 
                new Chapter { Title = "The Battle of Hogwarts" }, 
                new Chapter { Title = "The Elder Wand" }, 
                new Chapter { Title = "The prince's tale" }, 
                new Chapter { Title = "The forest again" }, 
                new Chapter { Title = "King's Cross" }, 
                new Chapter { Title = "The flaw in the plan" }
        };
            #endregion

            book1.ExpandChapters = new ObservableCollection<ObservableCollection<Chapter>> { 
                new ObservableCollection<Chapter> {new Chapter { Title = "The Dark Lord ascending" }}, 
                new ObservableCollection<Chapter> {new Chapter { Title = "The Dark Lord ascending" }}, 
                new ObservableCollection<Chapter> {new Chapter { Title = "In memoriam" }}, 
                new ObservableCollection<Chapter> {new Chapter { Title = "The Dursleys departing" }}, 
                new ObservableCollection<Chapter> {new Chapter { Title = "The seven Potters" }, 
                new Chapter { Title = "Fallen warrior" }, 
                new Chapter { Title = "The ghoul in pajamas" }, 
                new Chapter { Title = "The will of Albus Dumbledore" }, 
                new Chapter { Title = "The wedding" }, 
                new Chapter { Title = "A place to hide" }, 
                new Chapter { Title = "Kreacher's tale" }, 
                new Chapter { Title = "The bribe" }, 
                new Chapter { Title = "Magic is might" }, 
                new Chapter { Title = "The Muggle-born Registration Commission" }, 
                new Chapter { Title = "The thief" }, 
                new Chapter { Title = "The goblin's revenge" }, 
                new Chapter { Title = "Godric's Hollow" }, 
                new Chapter { Title = "Bathilda's secret" }, 
                new Chapter { Title = "The life and lies of Albus Dumbledore" }, 
                new Chapter { Title = "The silver doe" }, 
                new Chapter { Title = "Xenophilius Lovegood" }, 
                new Chapter { Title = "The tale of the three brothers" }, 
                new Chapter { Title = "The Deathly Hallows" }, 
                new Chapter { Title = "Malfoy Manor" }, 
                new Chapter { Title = "The wandmaker" }, 
                new Chapter { Title = "Shell Cottage" }, 
                new Chapter { Title = "Gringotts" }, 
                new Chapter { Title = "The final hiding place" }, 
                new Chapter { Title = "The missing mirror" }, 
                new Chapter { Title = "The lost diadem" }, 
                new Chapter { Title = "The sacking of Severus Snape" }, 
                new Chapter { Title = "The Battle of Hogwarts" }, 
                new Chapter { Title = "The Elder Wand" }, 
                new Chapter { Title = "The prince's tale" }, 
                new Chapter { Title = "The forest again" }, 
                new Chapter { Title = "King's Cross" }, 
                new Chapter { Title = "The flaw in the plan" },
                new Chapter { Title = "The forest again" }, 
                new Chapter { Title = "King's Cross" }, 
                new Chapter { Title = "The flaw in the plan" } }
        };

            book2.Title = "Silverlight 2 Programmer's Reference";
            book2.Author = "J. Ambrose Little, Jason Beres, Grant Hinkson, Devin Rader, Joe Croney";
            book2.ISBN = "0470385405";
            book2.InternetAddres = "www.google.com";

            book3.Title = "Silverlight 1.0";
            book3.Author = "Devin Rader, Jason Beres, J. Ambrose Little, Grant Hinkson";
            book3.ISBN = "0470228407";
            book3.InternetAddres = "www.google.com";
            book3.Chapters = new ObservableCollection<Chapter>() {
                new Chapter { Title = "Introduction to Silverlight"},
                new Chapter { Title = "Building Silverlight Applications Using XAML"}, 
                new Chapter { Title = "Designing Silverlight Applications Using Expression Blend 2"}, 
                new Chapter { Title = "Coding Silverlight Applications with JavaScript and XAML"}, 
                new Chapter { Title = "Using Silverlight with ASP.NET"}, 
                new Chapter { Title = "Silverlight 1.1 and the CLR"},
                new Chapter { Title = "Video Player: Silverlight 1.0 Case Example"}
        };
            book3.ExpandChapters = new ObservableCollection<ObservableCollection<Chapter>>() {
                new ObservableCollection<Chapter> {new Chapter { Title = "Introduction to Silverlight"}},
                new ObservableCollection<Chapter> {new Chapter { Title = "Building Silverlight Applications Using XAML"}}, 
                new ObservableCollection<Chapter> {new Chapter { Title = "Designing Silverlight Applications Using Expression Blend 2"}, 
                new Chapter { Title = "Coding Silverlight Applications with JavaScript and XAML"}, 
                new Chapter { Title = "Using Silverlight with ASP.NET"}, 
                new Chapter { Title = "Silverlight 1.1 and the CLR"},
                new Chapter { Title = "Video Player: Silverlight 1.0 Case Example"}}
        };

            ObservableCollection<DeepBook> deepBooks = new ObservableCollection<DeepBook>() { book1, book2, book3 };
            return deepBooks;
        }

        #endregion // EDeepBooks

        #region EDeepBooks2

        public static ObservableCollection<DeepBook2> EDeepBooks2()
        {
            #region Books
            Book book1 = new Book();
            Book book2 = new Book();
            Book book3 = new Book();

            book1.Title = "Harry Potter and the Deathly Hallows";
            book1.Author = "J. K. Rowling";
            book1.ISBN = "0545010225";
            book1.Chapters = new ObservableCollection<Chapter> { 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "In memoriam" }, 
                new Chapter { Title = "The Dursleys departing" }, 
                new Chapter { Title = "The seven Potters" }, 
                new Chapter { Title = "Fallen warrior" }, 
                new Chapter { Title = "The ghoul in pajamas" }, 
                new Chapter { Title = "The will of Albus Dumbledore" }, 
                new Chapter { Title = "The wedding" }, 
                new Chapter { Title = "A place to hide" }, 
                new Chapter { Title = "Kreacher's tale" }, 
                new Chapter { Title = "The bribe" }, 
                new Chapter { Title = "Magic is might" }, 
                new Chapter { Title = "The Muggle-born Registration Commission" }, 
                new Chapter { Title = "The thief" }, 
                new Chapter { Title = "The goblin's revenge" }, 
                new Chapter { Title = "Godric's Hollow" }, 
                new Chapter { Title = "Bathilda's secret" }, 
                new Chapter { Title = "The life and lies of Albus Dumbledore" }, 
                new Chapter { Title = "The silver doe" }, 
                new Chapter { Title = "Xenophilius Lovegood" }, 
                new Chapter { Title = "The tale of the three brothers" }, 
                new Chapter { Title = "The Deathly Hallows" }, 
                new Chapter { Title = "Malfoy Manor" }, 
                new Chapter { Title = "The wandmaker" }, 
                new Chapter { Title = "Shell Cottage" }, 
                new Chapter { Title = "Gringotts" }, 
                new Chapter { Title = "The final hiding place" }, 
                new Chapter { Title = "The missing mirror" }, 
                new Chapter { Title = "The lost diadem" }, 
                new Chapter { Title = "The sacking of Severus Snape" }, 
                new Chapter { Title = "The Battle of Hogwarts" }, 
                new Chapter { Title = "The Elder Wand" }, 
                new Chapter { Title = "The prince's tale" }, 
                new Chapter { Title = "The forest again" }, 
                new Chapter { Title = "King's Cross" }, 
                new Chapter { Title = "The flaw in the plan" }
        };

            book2.Title = "Silverlight 2 Programmer's Reference";
            book2.Author = "J. Ambrose Little, Jason Beres, Grant Hinkson, Devin Rader, Joe Croney";
            book2.ISBN = "0470385405";

            book3.Title = "Silverlight 1.0";
            book3.Author = "Devin Rader, Jason Beres, J. Ambrose Little, Grant Hinkson";
            book3.ISBN = "0470228407";
            book3.Chapters = new ObservableCollection<Chapter>() {
                new Chapter { Title = "Introduction to Silverlight"},
                new Chapter { Title = "Building Silverlight Applications Using XAML"}, 
                new Chapter { Title = "Designing Silverlight Applications Using Expression Blend 2"}, 
                new Chapter { Title = "Coding Silverlight Applications with JavaScript and XAML"}, 
                new Chapter { Title = "Using Silverlight with ASP.NET"}, 
                new Chapter { Title = "Silverlight 1.1 and the CLR"},
                new Chapter { Title = "Video Player: Silverlight 1.0 Case Example"}
        };
            #endregion

            DeepBook2 deepBook1 = new DeepBook2();
            DeepBook2 deepBook2 = new DeepBook2();
            DeepBook2 deepBook3 = new DeepBook2();

            deepBook1.Title = "Harry Potter and the Deathly Hallows";
            deepBook1.Author = "J. K. Rowling";
            deepBook1.ISBN = "0545010225";
            deepBook1.FamousAuthor = true;
            deepBook1.InternetAddres = new Uri("http://www.google.com/");
            deepBook1.Chapters = new ObservableCollection<Book> { book1, book2, book3 };
            #region ExpandChapters
            deepBook1.ExpandChapters = new ObservableCollection<Chapter> { 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "The Dark Lord ascending" }, 
                new Chapter { Title = "In memoriam" }, 
                new Chapter { Title = "The Dursleys departing" }, 
                new Chapter { Title = "The seven Potters" }, 
                new Chapter { Title = "Fallen warrior" }, 
                new Chapter { Title = "The ghoul in pajamas" }, 
                new Chapter { Title = "The will of Albus Dumbledore" }, 
                new Chapter { Title = "The wedding" }, 
                new Chapter { Title = "A place to hide" }, 
                new Chapter { Title = "Kreacher's tale" }, 
                new Chapter { Title = "The bribe" }, 
                new Chapter { Title = "Magic is might" }, 
                new Chapter { Title = "The Muggle-born Registration Commission" }, 
                new Chapter { Title = "The thief" }, 
                new Chapter { Title = "The goblin's revenge" }, 
                new Chapter { Title = "Godric's Hollow" }, 
                new Chapter { Title = "Bathilda's secret" }, 
                new Chapter { Title = "The life and lies of Albus Dumbledore" }, 
                new Chapter { Title = "The silver doe" }, 
                new Chapter { Title = "Xenophilius Lovegood" }, 
                new Chapter { Title = "The tale of the three brothers" }, 
                new Chapter { Title = "The Deathly Hallows" }, 
                new Chapter { Title = "Malfoy Manor" }, 
                new Chapter { Title = "The wandmaker" }, 
                new Chapter { Title = "Shell Cottage" }, 
                new Chapter { Title = "Gringotts" }, 
                new Chapter { Title = "The final hiding place" }, 
                new Chapter { Title = "The missing mirror" }, 
                new Chapter { Title = "The lost diadem" }, 
                new Chapter { Title = "The sacking of Severus Snape" }, 
                new Chapter { Title = "The Battle of Hogwarts" }, 
                new Chapter { Title = "The Elder Wand" }, 
                new Chapter { Title = "The prince's tale" }, 
                new Chapter { Title = "The forest again" }, 
                new Chapter { Title = "King's Cross" }, 
                new Chapter { Title = "The flaw in the plan" },
                new Chapter { Title = "The forest again" }, 
                new Chapter { Title = "King's Cross" }, 
                new Chapter { Title = "The flaw in the plan" }
        };
            #endregion

            deepBook2.Title = "Silverlight 2 Programmer's Reference";
            deepBook2.Author = "J. Ambrose Little, Jason Beres, Grant Hinkson, Devin Rader, Joe Croney";
            deepBook2.ISBN = "0470385405";
            deepBook2.InternetAddres = new Uri("http://www.google.com/");

            deepBook3.Title = "Silverlight 1.0";
            deepBook3.Author = "Devin Rader, Jason Beres, J. Ambrose Little, Grant Hinkson";
            deepBook3.ISBN = "0470228407";
            deepBook3.FamousAuthor = false;
            deepBook3.InternetAddres = new Uri("http://www.google.com/");
            deepBook3.Chapters = new ObservableCollection<Book>() { book1, book2, book3 };
            #region ExpandChapters
            deepBook3.ExpandChapters = new ObservableCollection<Chapter>() {
                new Chapter { Title = "Introduction to Silverlight"},
                new Chapter { Title = "Building Silverlight Applications Using XAML"}, 
                new Chapter { Title = "Designing Silverlight Applications Using Expression Blend 2"}, 
                new Chapter { Title = "Coding Silverlight Applications with JavaScript and XAML"}, 
                new Chapter { Title = "Using Silverlight with ASP.NET"}, 
                new Chapter { Title = "Silverlight 1.1 and the CLR"},
                new Chapter { Title = "Video Player: Silverlight 1.0 Case Example"}
        };
            #endregion

            ObservableCollection<DeepBook2> deepBooks2 = new ObservableCollection<DeepBook2>() { deepBook1, deepBook2, deepBook3 };
            return deepBooks2;
        }

        #endregion // EDeepBooks2

        #region EDeepBooks3

        public static ObservableCollection<DeepBook3> EDeepBooks3()
        {
            InternetChapter ic1 = new InternetChapter();
            InternetChapter ic2 = new InternetChapter();
            InternetChapter ic3 = new InternetChapter();

            ic1.InternetTitle = new Uri("http://www.google.com/");
            ic1.Good = false;

            ic2.InternetTitle = new Uri("http://www.google.com/");
            ic2.Good = true;

            ic3.InternetTitle = new Uri("http://www.google.com/");


            DeepBook3 deepBook1 = new DeepBook3();
            DeepBook3 deepBook2 = new DeepBook3();
            DeepBook3 deepBook3 = new DeepBook3();

            deepBook1.Title = "Harry Potter and the Deathly Hallows";
            deepBook1.Author = "J. K. Rowling";
            deepBook1.FamousAuthor = true;
            deepBook1.InternetAddres = new Uri("http://www.google.com/");
            deepBook1.IChapters = new ObservableCollection<InternetChapter>() { ic1, ic2, ic3 };

            deepBook2.Title = "Silverlight 2 Programmer's Reference";
            deepBook2.Author = "J. Ambrose Little, Jason Beres, Grant Hinkson, Devin Rader, Joe Croney";
            deepBook2.InternetAddres = new Uri("http://www.google.com/");

            deepBook3.Title = "Silverlight 1.0";
            deepBook3.Author = "Devin Rader, Jason Beres, J. Ambrose Little, Grant Hinkson";
            deepBook3.FamousAuthor = false;
            deepBook3.InternetAddres = new Uri("http://www.google.com/");

            ObservableCollection<DeepBook3> deepBooks3 = new ObservableCollection<DeepBook3>() { deepBook1, deepBook2, deepBook3 };
            return deepBooks3;
        }

        #endregion // EDeepBooks3

        #region BookStores

        public static ObservableCollection<BookStore> BookStoresData
        {
            get
            {
                return EBookStores();
            }
        }
        public static ObservableCollection<BookStore> EBookStores()
        {
            BookStore bookStore1 = new BookStore();
            BookStore bookStore2 = new BookStore();
            BookStore bookStore3 = new BookStore();

            #region BookStore 1

            bookStore1.StoreName = "Magic BookStore 1";
            bookStore1.Location = "Rowling Str. 1"; ;
            bookStore1.Books = DataGenerator.ELimitedBooks();
            bookStore1.Magazines = DataGenerator.CreateMagazines();

            #endregion // BookStore 1

            #region BookStore 2

            bookStore2.StoreName = "Magic BookStore 2";
            bookStore2.Location = "Saint City Str. 23";
            bookStore2.Books = new ObservableCollection<Book>();
            bookStore2.Magazines = new ObservableCollection<Magazine>();

            for (int i = 1; i < 6; i++)
            {
                bookStore2.Books.Add(new Book()
                {
                    Title = "Book " + i,
                    Author = "Aria Cruz",
                    ISBN = "34530909KJ",
                    Chapters = CreateChapters(i, 4)
                });

                bookStore2.Magazines.Add(new Magazine()
                {
                    MagazineTitle = "Magazine " + i,
                    Author = "Peter Schmitt",
                    Editions = CreateEditions(i, 3)
                });
            }

            #endregion // BookStore 2

            #region BookStore 3

            bookStore3.StoreName = "Magic BookStore 3";

            #endregion // BookStore 3


            ObservableCollection<BookStore> bookstores = new ObservableCollection<BookStore>()
            {
                bookStore1, 
                bookStore2, 
                bookStore3
            };

            return bookstores;
        }

        #endregion // BookStores

        #region BookCategories

        public static ObservableCollection<BookCategory> BookCategoryData
        {
            get
            {
                return EBookCategory();
            }
        }

        public static ObservableCollection<BookCategory> EBookCategory()
        {
            ObservableCollection<BookCategory> category = new ObservableCollection<BookCategory>();

            category.Add(new BookCategory()
            {
                CategoryName = "History",
                Books = EBookCategories()[0]
            });
            category.Add(new BookCategory()
            {
                CategoryName = "Art",
                Books = EBookCategories()[1]
            });
            category.Add(new BookCategory()
            {
                CategoryName = "Economics",
                Books = EBookCategories()[2]
            });
            category.Add(new BookCategory()
            {
                CategoryName = "Music",
                Books = EBookCategories()[3]
            });
            category.Add(new BookCategory()
            {
                CategoryName = "Religion",
                Books = EBookCategories()[4]
            });

            return category;
        }
        public static ObservableCollection<ObservableCollection<Book>> EBookCategories()
        {
            ObservableCollection<Book> category1 = new ObservableCollection<Book>();
            ObservableCollection<Book> category2 = new ObservableCollection<Book>();
            ObservableCollection<Book> category3 = new ObservableCollection<Book>();
            ObservableCollection<Book> category4 = new ObservableCollection<Book>();
            ObservableCollection<Book> category5 = new ObservableCollection<Book>();

            #region Category 1 - History

            category1.Add(new Book()
            {
                Title = "Ancient Persia",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "The Rise of Persia" },
                    new Chapter() { Title = "Babylon and the Medes" },
                    new Chapter() { Title = "The Iranian Religon" }
                },
                Author = "Gary Newman",
                ISBN = "2343454JS"
            });
            category1.Add(new Book()
            {
                Title = "Mesopotamia",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "A Civilization is Born" },
                    new Chapter() { Title = "The Early Dynastic History" },
                    new Chapter() { Title = "Conclusions" }
                },
                Author = "John Goodman",
                ISBN = "SD76786312"
            });
            category1.Add(new Book()
            {
                Title = "Babylonia and Assyria",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "Society and Economy" },
                    new Chapter() { Title = "Religions" },
                    new Chapter() { Title = "Material Cultue" }
                },
                Author = "Maria Anderson",
                ISBN = "2343454JS"
            });

            #endregion // Category 1 - History

            #region Category 2 - Art

            category2.Add(new Book()
            {
                Title = "Graphic Arts",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "Conditions and Foundations" },
                    new Chapter() { Title = "New Graphic Forms" },
                    new Chapter() { Title = "Expressionism" }
                },
                Author = "Antonio Moreno",
                ISBN = "9090UUU"
            });
            category2.Add(new Book()
            {
                Title = "Photography",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "Pre-Production" },
                    new Chapter() { Title = "The Photographic Image" },
                    new Chapter() { Title = "Post-Production" }
                },
                Author = "Christina Berglund",
                ISBN = "99TY7878"
            });
            category2.Add(new Book()
            {
                Title = "Sculpture",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "Greece and Rome: Man's Image" },
                    new Chapter() { Title = "Romanesque: Heaven and Earth" },
                    new Chapter() { Title = "Italian Renaissance" }
                },
                Author = "Sven Ottlieb",
                ISBN = "16726378177"
            });

            #endregion // Category 2 - Art

            #region Category 3 - Economics

            category3.Add(new Book()
            {
                Title = "Stock Marcket",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "Structural Factors" },
                    new Chapter() { Title = "Cultural Factors" },
                    new Chapter() { Title = "Psychological Factors" }
                },
                Author = "Victoria Ashworth",
                ISBN = "KK67283LL"
            });
            category3.Add(new Book()
            {
                Title = "Wall Street",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "The Early Years" },
                    new Chapter() { Title = "The Money Trust" },
                    new Chapter() { Title = "Bull Market" }
                },
                Author = "Peter Franken",
                ISBN = "04399II8R"
            });
            category3.Add(new Book()
            {
                Title = "Mutual Funds",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "Investment Goals and Opportunities" },
                    new Chapter() { Title = "Spot Assets" },
                    new Chapter() { Title = "Investment Companies" }
                },
                Author = "Carine Schmitt",
                ISBN = "16762OKH98"
            });

            #endregion // Category 3 - Economics

            #region Category 4 - Music

            category4.Add(new Book()
            {
                Title = "Blues Music",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "Got to Work or Leave" },
                    new Chapter() { Title = "Railroad for My Pillow" },
                    new Chapter() { Title = "Going Down Slow" }
                },
                Author = "Maria Larson",
                ISBN = "267J77556"

            });
            category4.Add(new Book()
            {
                Title = "National Athem",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "The American Revolution" },
                    new Chapter() { Title = "The Civil War" },
                    new Chapter() { Title = "The Korean War" }
                },
                Author = "Yoshi Latimer",
                ISBN = "92746JA5GG"
            });
            category4.Add(new Book()
            {
                Title = "Folk Music",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "Defining Folk Music" },
                    new Chapter() { Title = "General Characteristics" },
                    new Chapter() { Title = "The Ethnic Backgrounds" }
                },
                Author = "Manuel Pereira",
                ISBN = "234167654JS"
            });

            #endregion // Category 4 - Music

            #region Category 5 - Religion

            category5.Add(new Book()
            {
                Title = "Judaism",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "Jewish Jistory" },
                    new Chapter() { Title = "Beliefs and Practices" }
                },
                Author = "James Steel",
                ISBN = "8172I6FAS"
            });
            category5.Add(new Book()
            {
                Title = "Christianity",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "The Bible" },
                    new Chapter() { Title = "Orthodox Christianity" },
                    new Chapter() { Title = "Catholicism" }
                },
                Author = "Daniel Tonini",
                ISBN = "K23DS90906"
            });
            category5.Add(new Book()
            {
                Title = "Asian Religions",
                Chapters = new ObservableCollection<Chapter>()
                {
                    new Chapter() { Title = "Islam" },
                    new Chapter() { Title = "Buddism" }
                },
                Author = "Horst Kloss",
                ISBN = "23T34LL8A"
            });

            #endregion // Category 5 - Religion


            ObservableCollection<ObservableCollection<Book>> categories = new ObservableCollection<ObservableCollection<Book>>()
            {
                category1,
                category2,
                category3,
                category4,
                category5
            };

            return categories;
        }

        #endregion // BookCategories

        #region Magazines

        public static ObservableCollection<Edition> EditionsData
        {
            get
            {
                return CreateEditions();
            }
        }

        public static ObservableCollection<Edition> ENationalGeographicEditions()
        {
            Edition ngEdition1 = new Edition();
            Edition ngEdition2 = new Edition();
            Edition ngEdition3 = new Edition();

            ngEdition1.EditionName = "Merging Man and Machine";
            ngEdition1.Price = 2.5;
            ngEdition1.Rubrics = ENationalGeographicRubrics()[0];

            ngEdition2.EditionName = "Water: A Special Issue";
            ngEdition2.Price = 2.5;
            ngEdition2.Rubrics = ENationalGeographicRubrics()[1];

            ngEdition3.EditionName = "The Spill";
            ngEdition3.Price = 2.5;
            ngEdition3.Rubrics = ENationalGeographicRubrics()[2];


            ObservableCollection<Edition> ngEditions = new ObservableCollection<Edition>()
            {
                ngEdition1, 
                ngEdition2, 
                ngEdition3
            };

            return ngEditions;
        }
        public static ObservableCollection<Edition> EGeoEditions()
        {
            Edition geoEdition1 = new Edition();
            Edition geoEdition2 = new Edition();
            Edition geoEdition3 = new Edition();
            Edition geoEdition4 = new Edition();
            Edition geoEdition5 = new Edition();

            geoEdition1.EditionName = "Our New Palnet Earth";
            geoEdition1.Price = 2.0;
            geoEdition1.Rubrics = EGeoRubrics()[0];

            geoEdition2.EditionName = "Egypt";
            geoEdition2.Price = 2.0;
            geoEdition2.Rubrics = EGeoRubrics()[1];

            geoEdition3.EditionName = "Oceania: South Pacific Islands";
            geoEdition3.Price = 2.0;
            geoEdition3.Rubrics = EGeoRubrics()[2];

            geoEdition4.EditionName = "The Paradise";
            geoEdition4.Price = 2.0;
            geoEdition4.Rubrics = EGeoRubrics()[3];

            geoEdition5.EditionName = "Life Gallery";
            geoEdition5.Price = 2.0;
            geoEdition5.Rubrics = EGeoRubrics()[4];


            ObservableCollection<Edition> geoEditions = new ObservableCollection<Edition>()
            {
                geoEdition1, 
                geoEdition2, 
                geoEdition3, 
                geoEdition4, 
                geoEdition5
            };

            return geoEditions;
        }
        public static ObservableCollection<Edition> EScientificAmericanEditions()
        {
            Edition saEdition1 = new Edition();
            Edition saEdition2 = new Edition();

            saEdition1.EditionName = "Merging Man and Machine";
            saEdition1.Price = 3.0;
            saEdition1.Rubrics = EScientificAmericanRubrics()[0];

            saEdition2.EditionName = "Human Evolution Is Not Over";
            saEdition2.Price = 3.0;
            saEdition2.Rubrics = EScientificAmericanRubrics()[1];


            ObservableCollection<Edition> saEditions = new ObservableCollection<Edition>()
            {
                saEdition1, 
                saEdition2
            };

            return saEditions;
        }
        public static ObservableCollection<Edition> EOutsideEditions()
        {
            Edition oEdition1 = new Edition();
            Edition oEdition2 = new Edition();
            Edition oEdition3 = new Edition();

            oEdition1.EditionName = "Yout Guide To Life";
            oEdition1.Price = 1.5;
            oEdition1.Rubrics = EOutsideRubrics()[0];

            oEdition2.EditionName = "Jumping From 120,000 Feet";
            oEdition2.Price = 1.5;
            oEdition2.Rubrics = EOutsideRubrics()[1];

            oEdition3.EditionName = "Photo Issue";
            oEdition3.Price = 1.5;
            oEdition3.Rubrics = EOutsideRubrics()[2];


            ObservableCollection<Edition> oEditions = new ObservableCollection<Edition>()
            {
                oEdition1,
                oEdition2, 
                oEdition3
            };

            return oEditions;
        }

        #endregion // Magazines

        #region Rubrics

        public static ObservableCollection<RubricExt> RubricsExtData
        {
            get
            {
                return CreateRubricsExt();
            }
        }

        public static ObservableCollection<ObservableCollection<Rubric>> ENationalGeographicRubrics()
        {
            Rubric rubric1 = new Rubric() { Heading = "1: The Singapore Solution", Index = 1, PublishDate = new DateTime() };
            Rubric rubric2 = new Rubric() { Heading = "2: Sublime Scottish Islands", Index = 2, PublishDate = new DateTime() };
            Rubric rubric3 = new Rubric() { Heading = "3: Wide Angel", Index = 3, PublishDate = new DateTime() };
            Rubric rubric4 = new Rubric() { Heading = "4: Restless Spirits", Index = 4, PublishDate = new DateTime() };
            Rubric rubric5 = new Rubric() { Heading = "5: Asia's Widelife Trade", Index = 5, PublishDate = new DateTime() };

            Rubric rubric6 = new Rubric() { Heading = "1: The Burden of Thirst", Index = 1, PublishDate = new DateTime() };
            Rubric rubric7 = new Rubric() { Heading = "2: Vision of Earth", Index = 2, PublishDate = new DateTime() };
            Rubric rubric8 = new Rubric() { Heading = "3: Silent Stream", Index = 3, PublishDate = new DateTime() };

            Rubric rubric9 = new Rubric() { Heading = "1: My Blue Wilderness", Index = 1, PublishDate = new DateTime() };
            Rubric rubric10 = new Rubric() { Heading = "2: Australia's Lost Giant", Index = 2, PublishDate = new DateTime() };
            Rubric rubric11 = new Rubric() { Heading = "3: Time for a Sea Change", Index = 3, PublishDate = new DateTime() };
            Rubric rubric12 = new Rubric() { Heading = "4: Being Jane Goodall", Index = 4, PublishDate = new DateTime() };
            Rubric rubric13 = new Rubric() { Heading = "5: X-Ray Visions", Index = 5, PublishDate = new DateTime() };
            Rubric rubric14 = new Rubric() { Heading = "6: Under the Big Sky", Index = 6, PublishDate = new DateTime() };
            Rubric rubric15 = new Rubric() { Heading = "7: The Big Idea: Laser Preservation", Index = 7, PublishDate = new DateTime() };



            ObservableCollection<Rubric> rubrics1 = new ObservableCollection<Rubric>()
            {
                rubric1, 
                rubric2, 
                rubric3, 
                rubric4, 
                rubric5
            };
            ObservableCollection<Rubric> rubrics2 = new ObservableCollection<Rubric>()
            {
                rubric6, 
                rubric7, 
                rubric8
            };
            ObservableCollection<Rubric> rubrics3 = new ObservableCollection<Rubric>()
            {
                rubric9, 
                rubric10, 
                rubric11, 
                rubric12, 
                rubric13, 
                rubric14, 
                rubric15
            };


            ObservableCollection<ObservableCollection<Rubric>> rubrics = new ObservableCollection<ObservableCollection<Rubric>>()
            {
                rubrics1, 
                rubrics2, 
                rubrics3
            };

            return rubrics;
        }
        public static ObservableCollection<ObservableCollection<Rubric>> EGeoRubrics()
        {
            Rubric rubric1 = new Rubric() { Heading = "1: What Is Beauty", Index = 1, PublishDate = new DateTime() };
            Rubric rubric2 = new Rubric() { Heading = "2: The Chinese Desert Expedition", Index = 2, PublishDate = new DateTime() };
            Rubric rubric3 = new Rubric() { Heading = "3: Tonga", Index = 3, PublishDate = new DateTime() };

            Rubric rubric4 = new Rubric() { Heading = "1: Mexico", Index = 1, PublishDate = new DateTime() };
            Rubric rubric5 = new Rubric() { Heading = "2: Charles Darwin 2", Index = 2, PublishDate = new DateTime() };

            Rubric rubric6 = new Rubric() { Heading = "1: The Berlin Wall", Index = 1, PublishDate = new DateTime() };
            Rubric rubric7 = new Rubric() { Heading = "2: Saudi Arabia", Index = 2, PublishDate = new DateTime() };
            Rubric rubric8 = new Rubric() { Heading = "3: South Rodopi Mountain", Index = 3, PublishDate = new DateTime() };
            Rubric rubric9 = new Rubric() { Heading = "4: The Universe", Index = 4, PublishDate = new DateTime() };
            Rubric rubric10 = new Rubric() { Heading = "5: Nikola Tesla", Index = 5, PublishDate = new DateTime() };
            Rubric rubric11 = new Rubric() { Heading = "6: Venice", Index = 6, PublishDate = new DateTime() };
            Rubric rubric12 = new Rubric() { Heading = "7: Kongo River", Index = 7, PublishDate = new DateTime() };

            Rubric rubric13 = new Rubric() { Heading = "1: Genetically Modified Organisms", Index = 1, PublishDate = new DateTime() };

            Rubric rubric14 = new Rubric() { Heading = "1: Sahara", Index = 1, PublishDate = new DateTime() };
            Rubric rubric15 = new Rubric() { Heading = "2: Arktika", Index = 2, PublishDate = new DateTime() };
            Rubric rubric16 = new Rubric() { Heading = "3: Uranium Hunters", Index = 3, PublishDate = new DateTime() };


            ObservableCollection<Rubric> rubrics1 = new ObservableCollection<Rubric>()
            {
                rubric1, 
                rubric2, 
                rubric3
            };
            ObservableCollection<Rubric> rubrics2 = new ObservableCollection<Rubric>()
            {
                rubric4, 
                rubric5
            };
            ObservableCollection<Rubric> rubrics3 = new ObservableCollection<Rubric>()
            {
                rubric6, 
                rubric7, 
                rubric8, 
                rubric9, 
                rubric10, 
                rubric11, 
                rubric12
            };
            ObservableCollection<Rubric> rubrics4 = new ObservableCollection<Rubric>()
            {
                rubric13
            };
            ObservableCollection<Rubric> rubrics5 = new ObservableCollection<Rubric>()
            {
                rubric14, 
                rubric15, 
                rubric16
            };

            ObservableCollection<ObservableCollection<Rubric>> rubrics = new ObservableCollection<ObservableCollection<Rubric>>()
            {
                rubrics1, 
                rubrics2, 
                rubrics3, 
                rubrics4, 
                rubrics5
            };

            return rubrics;
        }
        public static ObservableCollection<ObservableCollection<Rubric>> EScientificAmericanRubrics()
        {
            Rubric rubric1 = new Rubric() { Heading = "1: Controlling the Brain with Light", Index = 1, PublishDate = new DateTime() };
            Rubric rubric2 = new Rubric() { Heading = "2: Dark Worlds", Index = 2, PublishDate = new DateTime() };
            Rubric rubric3 = new Rubric() { Heading = "3: How to Build the Supergrid", Index = 3, PublishDate = new DateTime() };
            Rubric rubric4 = new Rubric() { Heading = "4: Phosphorus Lake", Index = 4, PublishDate = new DateTime() };

            Rubric rubric5 = new Rubric() { Heading = "1: How We Are Evolving", Index = 1, PublishDate = new DateTime() };
            Rubric rubric6 = new Rubric() { Heading = "2: The Elusive Theory of Everything", Index = 2, PublishDate = new DateTime() };
            Rubric rubric7 = new Rubric() { Heading = "3: Robot Be Good", Index = 3, PublishDate = new DateTime() };


            ObservableCollection<Rubric> rubrics1 = new ObservableCollection<Rubric>()
            {
                rubric1, 
                rubric2, 
                rubric3, 
                rubric4
            };
            ObservableCollection<Rubric> rubrics2 = new ObservableCollection<Rubric>()
            {
                rubric5, 
                rubric6, 
                rubric7
            };

            ObservableCollection<ObservableCollection<Rubric>> rubrics = new ObservableCollection<ObservableCollection<Rubric>>()
            {
                rubrics1, 
                rubrics2
            };

            return rubrics;
        }
        public static ObservableCollection<ObservableCollection<Rubric>> EOutsideRubrics()
        {
            Rubric rubric1 = new Rubric() { Heading = "1: Clutch Cargo", Index = 1, PublishDate = new DateTime() };
            Rubric rubric2 = new Rubric() { Heading = "2: Bachalor of Lost Arts", Index = 2, PublishDate = new DateTime() };
            Rubric rubric3 = new Rubric() { Heading = "3: Step Into Celluloid", Index = 3, PublishDate = new DateTime() };
            Rubric rubric4 = new Rubric() { Heading = "4: Twin Freaks", Index = 4, PublishDate = new DateTime() };
            Rubric rubric5 = new Rubric() { Heading = "5: Heart of Dark Chocolate", Index = 5, PublishDate = new DateTime() };

            Rubric rubric6 = new Rubric() { Heading = "1: The Supersonic Man", Index = 1, PublishDate = new DateTime() };
            Rubric rubric7 = new Rubric() { Heading = "2: The Natural", Index = 2, PublishDate = new DateTime() };
            Rubric rubric8 = new Rubric() { Heading = "3: Steamed", Index = 3, PublishDate = new DateTime() };

            Rubric rubric9 = new Rubric() { Heading = "1: The Amateurs", Index = 1, PublishDate = new DateTime() };
            Rubric rubric10 = new Rubric() { Heading = "2: Liquid Cure", Index = 2, PublishDate = new DateTime() };
            Rubric rubric11 = new Rubric() { Heading = "3: Between The Devil And The Deep Blue Sea", Index = 3, PublishDate = new DateTime() };
            Rubric rubric12 = new Rubric() { Heading = "4: My Toughest Shot", Index = 4, PublishDate = new DateTime() };
            Rubric rubric13 = new Rubric() { Heading = "5: See It Their Way", Index = 5, PublishDate = new DateTime() };
            Rubric rubric14 = new Rubric() { Heading = "6: The Big Idea", Index = 6, PublishDate = new DateTime() };


            ObservableCollection<Rubric> rubrics1 = new ObservableCollection<Rubric>()
            {
                rubric1, 
                rubric2, 
                rubric3, 
                rubric4, 
                rubric5
            };
            ObservableCollection<Rubric> rubrics2 = new ObservableCollection<Rubric>()
            {
                rubric6, 
                rubric7, 
                rubric8
            };
            ObservableCollection<Rubric> rubrics3 = new ObservableCollection<Rubric>()
            {
                rubric9, 
                rubric10, 
                rubric11, 
                rubric12, 
                rubric13, 
                rubric14
            };

            ObservableCollection<ObservableCollection<Rubric>> rubrics = new ObservableCollection<ObservableCollection<Rubric>>()
            {
                rubrics1, 
                rubrics2, 
                rubrics3
            };

            return rubrics;
        }

        #endregion // Rubrics

        #region Create Methods

        public static ObservableCollection<Magazine> CreateMagazines()
        {
            ObservableCollection<Magazine> magazines = new ObservableCollection<Magazine>()
            {
                new Magazine()
                {
                    MagazineTitle = "National Geographic",
                    Author = "Hanna Moos",
                    Editions = ENationalGeographicEditions()
                },
                new Magazine()
                {
                    MagazineTitle = "GEO",
                    Author = "Thomas Hardy",
                    Editions = EGeoEditions()
                },
                new Magazine()
                {
                    MagazineTitle = "Scientific American",
                    Author = "Elizabeth Lincoln",
                    Editions = EScientificAmericanEditions()
                },
                new Magazine()
                {
                    MagazineTitle = "Smithsonian",
                    Author = "Ann Devon"
                },
                new Magazine()
                {
                    MagazineTitle = "Outside",
                    Author = "Roland Mendel",
                    Editions = EOutsideEditions()
                }
            };


            return magazines;
        }
        public static ObservableCollection<Chapter> CreateChapters(int bookIndex = 0, int chaptersUpperIndex = 5)
        {
            ObservableCollection<Chapter> chapters = new ObservableCollection<Chapter>();

            for (int i = 0; i < chaptersUpperIndex; i++)
            {
                chapters.Add(new Chapter()
                {
                    Title = "Chapter " + bookIndex + "." + i
                });
            }

            return chapters;
        }
        public static ObservableCollection<Edition> CreateEditions(int magazineIndex = 0, int magazinesUpperIndex = 5)
        {
            ObservableCollection<Edition> editions = new ObservableCollection<Edition>();

            for (int i = 0; i < magazinesUpperIndex; i++)
            {
                editions.Add(new Edition()
                {
                    EditionName = "Edition " + magazineIndex + "." + i,
                    Rubrics = CreateRubrics(magazineIndex, i),
                    Price = 12.2
                });
            }

            return editions;
        }
        public static ObservableCollection<Rubric> CreateRubrics(int editionIndex = 0, int rubricIndex = 0, int rubricsUpperIndex = 4)
        {
            ObservableCollection<Rubric> rubrics = new ObservableCollection<Rubric>();

            for (int i = 0; i < rubricsUpperIndex; i++)
            {
                rubrics.Add(new Rubric()
                {
                    Heading = (i + 1) + ": Heading " + editionIndex + "." + rubricIndex + "." + i,
                    Index = i + 1,
                    PublishDate = new DateTime()
                });
            }

            return rubrics;
        }
        public static ObservableCollection<RubricExt> CreateRubricsExt(int editionIndex = 0, int rubricIndex = 0, int rubricsUpperIndex = 4)
        {
            ObservableCollection<RubricExt> rubrics = new ObservableCollection<RubricExt>();
            BitmapImage picture = new BitmapImage(new Uri("/Infragistics.Testing.Beds.Shared;component/Resources/png/16x16/anchor.png", UriKind.Relative));

            for (int i = 0; i < rubricsUpperIndex; i++)
            {
                rubrics.Add(new RubricExt()
                {
                    Heading = (i + 1) + ": Heading " + editionIndex + "." + rubricIndex + "." + i,
                    Index = i + 1,
                    PublishDate = new DateTime(),
                    Picture = picture
                });
            }

            return rubrics;
        }

        #endregion // Create Methods
    }

    #endregion // DataGenerators
}
